#!/usr/bin/env python
# -*- coding: utf-8 -*-

# GIMP plugin add an inverted stack of all layers
# (c) Ofnuts 2012
#
#   History:
#
#   v0.0: 2012-06-22: First published version
#   v0.1: 2012-06-22: Don't dup layers at both ends
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from gimpfu import *
import os,sys


def mirrorLayers(image):
	image.undo_group_start()
	sourceLayers=image.layers[1:-1] # all but those at the ends
	for layer in sourceLayers:
		mirrorLayer=layer.copy()
		mirrorLayer.name='Mirrored '+layer.name
		image.add_layer(mirrorLayer,0)
	image.undo_group_end()

### Registrations
whoiam='\n'+os.path.abspath(sys.argv[0])
    
register(
    'mirror-layers',
    'Celem jest stworzenie warstw odpowiadających "powrotowi" w animacji. Warstwy skrajne (na obu końcach) nie są kopiowane'+whoiam,
    'Mirror layers',
    'Ofnuts',
    'Ofnuts',
    '2012',
    'Lustrzana kopia warstw',
    '*',
    [
        (PF_IMAGE, 'image', 'Input image', None),
    ],
    [],
    mirrorLayers,
    menu='<Image>/Image'
)

main()
