#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

# GIMP plugin to generate autocrop linked layers
# (c) Ofnuts 2013
#
#   History:
#
#   v0.0: 2013-09-02: First published version
#   v0.1: 2013-09-02: Add opacity/mode
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from gimpfu import *

MODES=[NORMAL_MODE, DISSOLVE_MODE, MULTIPLY_MODE, DIVIDE_MODE, SCREEN_MODE, OVERLAY_MODE, DODGE_MODE, BURN_MODE, HARDLIGHT_MODE, SOFTLIGHT_MODE, GRAIN_EXTRACT_MODE, GRAIN_MERGE_MODE, DIFFERENCE_MODE, ADDITION_MODE, SUBTRACT_MODE, DARKEN_ONLY_MODE, LIGHTEN_ONLY_MODE, HUE_MODE, SATURATION_MODE, COLOR_MODE, VALUE_MODE]
MODES_LABELS=['Zwykły','Przenikanie','Mnożenie','Dzielenie','Przesiewanie','Pokrywanie','Rozjaśnianie','Przyciemnianie','Twarde światło','Miękie światło','Wydobycie ziarna','Połączenie ziarna','Różnica','Suma','Odejmowanie','Tylko ciemniejsze','Tylko jaśniejsze','Barwa','Nasycenie','Kolor','Wartość']

def mergePairs(image, drawable,opacity,mode):
	pdb.gimp_image_undo_group_start(image)
	for i in range(len(image.layers)/2):
		image.layers[i+1].name=image.layers[i+1].name + ' + ' + image.layers[i].name
		image.layers[i].mode=MODES[mode]
		image.layers[i].opacity=opacity
		image.merge_down(image.layers[i],EXPAND_AS_NECESSARY)
	pdb.gimp_image_undo_group_end(image)

### Registrations
desc='Połącz w dół parami'
register(
    'merge-layer-pairs_pl',
    'Łączenie warstw parami (od górnej). \nOpcje poniżej działają dla obrazów w trybie "RGB" i "Odcienie szarości".',desc,'Ofnuts','Ofnuts','2013',desc,
    '*',
    [
        (PF_IMAGE, "image", "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),		
        (PF_SLIDER, 'opacity',  'Krycie:', 100, (0, 100, 1)),
	(PF_OPTION, 'mode', 'Tryb:', 0, MODES_LABELS)
    ],
    [],
    mergePairs,
    menu="<Layers>/Animacja",
)

main()
